diff -uwr sourceold/scripts/gmgame.cpp source/scripts/gmgame.cpp
--- sourceold/scripts/gmgame.cpp	2012-02-18 09:50:34.050781200 +0800
+++ source/scripts/gmgame.cpp	2012-05-16 00:26:42.453125000 +0800
@@ -97,13 +97,13 @@
 
 const char *Get_Translated_Preset_Name_Part(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return newstr("None");
 	}
 	const char *preset = Get_Translated_Preset_Name_Ini(obj);
 	StringClass preset2 = preset;
-	if (Is_Building(obj) || Is_DecorationPhys(obj) || Is_Harvester_Preset(obj))
+	if (obj->As_BuildingGameObj() || (obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->Peek_Physical_Object() && obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_DecorationPhysClass()) || Is_Harvester_Preset(obj))
 	{
 		const char *str = Get_Team_Name(Get_Object_Type(obj));
 		if (!stristr(preset,str))
@@ -120,7 +120,11 @@
 
 SCRIPTS_API const char *Get_Translated_Preset_Name_Ini(GameObject *obj)
 {
-	if (Is_C4(obj))
+	if (!obj)
+	{
+		return newstr("");
+	}
+	if (obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->As_C4GameObj())
 	{
 		if (Get_C4_Mode(obj) == 1)
 		{
@@ -153,7 +157,7 @@
 
 SCRIPTS_API const char *Get_Translated_Preset_Name_Ex(GameObject *obj)
 {
-	if (!Commands->Get_ID(obj) || (!obj))
+	if (!obj)
 	{
 		return newstr("None");
 	}
@@ -245,6 +249,7 @@
 	h->hook = ObjectCreateHook;
 	AddObjectCreateHook(h);
 	AddLoadLevelHook(LoadLevelHook);
+	AddPreLoadLevelHook(PreLoadLevelHook);
 	AddGameOverHook(GameOverHook);
 	AddPlayerJoinHook(PlayerJoinHook);
 	AddPlayerLeaveHook(PlayerLeaveHook);
@@ -369,7 +374,7 @@
 	return true;
 }
 
-bool SSGMGameManager::RadioHook(int PlayerType, int PlayerID, int AnnouncementID, int IconID, uint8 AnnouncementType)
+bool SSGMGameManager::RadioHook(int PlayerType, int PlayerID, int AnnouncementID, int IconID, AnnouncementEnum AnnouncementType)
 {
 	for (int i = 0;i < RegisteredEvents[EVENT_RADIO_HOOK].Count();i++)
 	{
@@ -416,18 +421,18 @@
 			Commands->Apply_Damage(obj,99999,"Death",0);
 		}
 	}
-	else if (Is_Powerup(obj))
+	else if (obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->As_PowerUpGameObj())
 	{
 		if (PlayPowerupSounds)
 		{
 			Attach_Script_Once(obj,"SSGM_Powerup","");
 		}
 	}
-	else if (Is_Beacon(obj))
+	else if (obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->As_BeaconGameObj())
 	{
 		Attach_Script_Once(obj,"SSGM_Log_Beacon","");
 	}
-	else if (Is_C4(obj))
+	else if (obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->As_C4GameObj())
 	{
 		Attach_Script_Once(obj,"SSGM_Log_Mine","");
 	}
@@ -683,6 +688,14 @@
 	Release_INI(SSGMIni);
 }
 
+void SSGMGameManager::PreLoadLevelHook()
+{
+	for (int i = 0;i < RegisteredEvents[EVENT_PRE_LOAD_LEVEL_HOOK].Count();i++)
+	{
+		RegisteredEvents[EVENT_PRE_LOAD_LEVEL_HOOK][i]->OnPreLoadLevel();
+	}
+}
+
 void SSGMGameManager::LoadLevelHook()
 {
 	RawFileClass file("SSGM.ini");
@@ -710,23 +723,23 @@
 		BuildingGameObj *o = x->Data();
 		if (o)
 		{
-			if (DisablePowerPlants && o->As_PowerPlantGameObj())
+			if (DisablePowerPlants && o->Get_Definition().Get_Type() == BuildingConstants::TYPE_POWER_PLANT)
 			{
 				Commands->Apply_Damage(o,99999,"Death",0);
 			}
-			else if (DisableRefineries && o->As_RefineryGameObj())
+			else if (DisableSoldierFactories && o->Get_Definition().Get_Type() == BuildingConstants::TYPE_SOLDIER_FACTORY)
 			{
 				Commands->Apply_Damage(o,99999,"Death",0);
 			}
-			else if (DisableSoldierFactories && o->As_SoldierFactoryGameObj())
+			else if (DisableVehicleFactories && o->Get_Definition().Get_Type() == BuildingConstants::TYPE_VEHICLE_FACTORY)
 			{
 				Commands->Apply_Damage(o,99999,"Death",0);
 			}
-			else if (DisableVehicleFactories && o->As_VehicleFactoryGameObj())
+			else if (DisableRefineries && o->Get_Definition().Get_Type() == BuildingConstants::TYPE_REFINERY)
 			{
 				Commands->Apply_Damage(o,99999,"Death",0);
 			}
-			else if (DisableRepairPads && o->As_RepairBayGameObj())
+			else if (DisableCommCenters && o->Get_Definition().Get_Type() == BuildingConstants::TYPE_COM_CENTER)
 			{
 				Commands->Apply_Damage(o,99999,"Death",0);
 			}
@@ -734,11 +747,15 @@
 			{
 				Commands->Apply_Damage(o,99999,"Death",0);
 			}
-			else if (DisableCommCenters && o->As_ComCenterGameObj())
+			else if (DisableShrines && o->Get_Definition().Get_Type() == BuildingConstants::TYPE_SHRINE)
 			{
 				Commands->Apply_Damage(o,99999,"Death",0);
 			}
-			else if (DisableConstructionYards && o->As_ConstructionYardGameObj())
+			else if (DisableHelipads && o->Get_Definition().Get_Type() == BuildingConstants::TYPE_HELIPAD)
+			{
+				Commands->Apply_Damage(o,99999,"Death",0);
+			}
+			else if (DisableConstructionYards && o->Get_Definition().Get_Type() == BuildingConstants::TYPE_CONYARD)
 			{
 				Commands->Apply_Damage(o,99999,"Death",0);
 			}
@@ -746,11 +763,15 @@
 			{
 				Commands->Apply_Damage(o,99999,"Death",0);
 			}
-			else if (DisableShrines && o->Get_Definition().Get_Type() == BuildingConstants::TYPE_SHRINE)
+			else if (DisableTechCenters && o->Get_Definition().Get_Type() == BuildingConstants::TYPE_TECH_CENTER)
 			{
 				Commands->Apply_Damage(o,99999,"Death",0);
 			}
-			else if (DisableHelipads && o->Get_Definition().Get_Type() == BuildingConstants::TYPE_HELIPAD)
+			else if (DisableNavalFactories && o->Get_Definition().Get_Type() == BuildingConstants::TYPE_NAVAL_FACTORY)
+			{
+				Commands->Apply_Damage(o,99999,"Death",0);
+			}
+			else if (DisableSpecials && o->Get_Definition().Get_Type() == BuildingConstants::TYPE_SPECIAL)
 			{
 				Commands->Apply_Damage(o,99999,"Death",0);
 			}
@@ -761,15 +782,15 @@
 		}
 		x = x->Next();
 	}
-	SLNode<SmartGameObj> *x2 = GameObjManager::SmartGameObjList.Head();
+	SLNode<VehicleGameObj> *x2 = GameObjManager::VehicleGameObjList.Head();
 	while (x2)
 	{
-		SmartGameObj *o = x2->Data();
+		VehicleGameObj *o = x2->Data();
 		if (o)
 		{
-			if (o->As_VehicleGameObj())
+			if (o)
 			{
-				if (o->As_VehicleGameObj()->Is_Turret())
+				if (o->Is_Turret())
 				{
 					if (DisableBaseDefenses)
 					{
@@ -1101,6 +1122,8 @@
 
 void SSGM_Log_Mine::Created(GameObject *obj)
 {
+	WasDetonated = false;
+	WasDisarmed = false;
 	Vector3 pos = Commands->Get_Position(obj);
 	SSGMGameLog::Log_Gamelog("CREATED;OBJECT;%d;%s;%d;%d;%d;%d;%d;%d;%d;%d", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(pos.Y),int(pos.X),int(pos.Z), int(Commands->Get_Facing(obj)), int(Commands->Get_Max_Health(obj)), int(Commands->Get_Max_Shield_Strength(obj)), Get_Object_Type(obj),Commands->Get_ID(Get_C4_Planter(obj)));
 }
@@ -1110,6 +1133,12 @@
 	Vector3	pos = Commands->Get_Position(obj);
 	if (!WasDisarmed && WasDetonated)
 	{
+		StringClass str;
+		const char *str4 = Get_Team_Name(Get_Object_Type(obj));
+		const char *str5 = Get_Translated_Preset_Name_Ini(obj);
+		const char *str6 = Get_Translated_Preset_Name_Ini(Get_C4_Attached(obj));
+		str.Format("%s %s has detonated (Owner: %ls - Attached to: %s)",str4,str5,Get_Wide_Player_Name(Get_C4_Planter(obj)),str6);
+		SSGMGameLog::Log_Message(str,"_C4");
 		SSGMGameLog::Log_Gamelog("DETONATED;OBJECT;%d;%s;%d;%d;%d", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(pos.Y), int(pos.X), int(pos.Z));
 	}
 	SSGMGameLog::Log_Gamelog("DESTROYED;OBJECT;%d;%s;%d;%d;%d", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(pos.Y), int(pos.X), int(pos.Z));
@@ -1137,6 +1166,15 @@
 	const char *str = Get_Translated_Preset_Name_Ex(obj);
 	const char *str2 = Get_Translated_Preset_Name_Ex(killer);
 	SSGMGameLog::Log_Gamelog("KILLED;OBJECT;%d;%s;%d;%d;%d;%d;%d;%s;%d;%d;%d;%d;%s;%s;%s",Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(victimpos.Y), int(victimpos.X), int(victimpos.Z), int(Commands->Get_Facing(obj)), Commands->Get_ID(killer),	Commands->Get_Preset_Name(killer),	int(damagerpos.Y), int(damagerpos.X), int(damagerpos.Z), int(Commands->Get_Facing(killer)),Get_Current_Weapon(killer),str,str2);
+	StringClass str3;
+	const char *str4 = Get_Team_Name(Get_Object_Type(obj));
+	const char *str5 = Get_Translated_Preset_Name_Ini(obj);
+	const char *str6 = Get_Translated_Preset_Name_Ini(Get_C4_Attached(obj));
+	str3.Format("%s %s has been disarmed by %ls (Owner: %ls - Attached to: %s)",str4,str5,Get_Wide_Player_Name(killer),Get_Wide_Player_Name(Get_C4_Planter(obj)),str6);
+	delete[] str4;
+	delete[] str5;
+	delete[] str6;
+	SSGMGameLog::Log_Message(str3,"_C4");
 	delete[] str;
 	delete[] str2;
 
@@ -1145,13 +1183,17 @@
 		if (Commands->Get_Player_Type(killer) == 0)
 		{
 			char disarmer[250];
-			sprintf(disarmer,"%ls disarmed a %s",Get_Wide_Player_Name(killer),Get_Translated_Preset_Name_Ex(obj));
+			const char *s1 = Get_Translated_Preset_Name_Ex(obj);
+			sprintf(disarmer,"%ls disarmed a %s",Get_Wide_Player_Name(killer),s1);
+			delete[] s1;
 			Send_Message_Team(0,104,234,40,disarmer);
 		}
 		else if (Commands->Get_Player_Type(killer) == 1)
 		{
 			char disarmer[250];
-			sprintf(disarmer,"%ls disarmed a %s",Get_Wide_Player_Name(killer),Get_Translated_Preset_Name_Ex(obj));
+			const char *s1 = Get_Translated_Preset_Name_Ex(obj);
+			sprintf(disarmer,"%ls disarmed a %s",Get_Wide_Player_Name(killer),s1);
+			delete[] s1;
 			Send_Message_Team(1,104,234,40,disarmer);
 		}
 	}
@@ -1185,6 +1227,13 @@
 
 void SSGM_Log_Beacon::Damaged(GameObject *obj, GameObject *damager, float amount)
 {
+	if (amount == 0 && damager == Get_Beacon_Planter(obj))
+	{
+		StringClass str3;
+		const char *str4 = Get_Translated_Preset_Name_Ini(obj);
+		str3.Format("%s has detonated",str4);
+		SSGMGameLog::Log_Message(str3,"_BEACON");
+	}
 	if (amount != 0)
 	{
 		Vector3	victimpos =	Commands->Get_Position(obj);
@@ -1200,7 +1249,9 @@
 				triggerrepairing = false;
 				int team = Commands->Get_Player_Type(damager);
 				char disarmer[250];
-				sprintf(disarmer,"%ls is disarming a %s",Get_Wide_Player_Name(damager),Get_Translated_Preset_Name_Ex(obj));
+				const char *s1 = Get_Translated_Preset_Name_Ex(obj);
+				sprintf(disarmer,"%ls is disarming a %s",Get_Wide_Player_Name(damager),s1);
+				delete[] s1;
 				Send_Message_Team(team,104,234,40,disarmer);
 				Commands->Start_Timer(obj,this,15.0f,222222);
 			}
@@ -1217,15 +1268,35 @@
 	SSGMGameLog::Log_Gamelog("KILLED;OBJECT;%d;%s;%d;%d;%d;%d;%d;%s;%d;%d;%d;%d;%s;%s;%s",Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(victimpos.Y), int(victimpos.X), int(victimpos.Z), int(Commands->Get_Facing(obj)), Commands->Get_ID(killer),	Commands->Get_Preset_Name(killer),	int(damagerpos.Y), int(damagerpos.X), int(damagerpos.Z), int(Commands->Get_Facing(killer)),Get_Current_Weapon(killer),str,str2);
 	delete[] str;
 	delete[] str2;
+	StringClass str3;
+	const char *str4 = Get_Translated_Preset_Name_Ini(obj);
+	str3.Format("%ls disarmed a %s",Get_Wide_Player_Name(killer),str4);
+	SSGMGameLog::Log_Message(str3,"_BEACON");
+	delete[] str4;
 
 	if (ShowExtraMessages)
 	{
 		char disarmer[250];
-		sprintf(disarmer,"%ls disarmed a %s",Get_Wide_Player_Name(killer),Get_Translated_Preset_Name_Ex(obj));
+		const char *s1 = Get_Translated_Preset_Name_Ex(obj);
+		sprintf(disarmer,"%ls disarmed a %s",Get_Wide_Player_Name(killer),s1);
+		delete[] s1;
 		Send_Message(104,234,40,disarmer);
 	}
 }
 
+void SSGM_Log_Beacon::Custom(GameObject *obj, int message, int param, GameObject *sender)
+{
+	if (message == CUSTOM_EVENT_BEACON_DEPLOYED)
+	{
+		StringClass str3;
+		const char *str4 = Get_Translated_Preset_Name_Ini(obj);
+		str3.Format("%ls deployed a %s",Get_Wide_Player_Name(sender),str4);
+		SSGMGameLog::Log_Message(str3,"_BEACON");
+		delete[] str4;
+	}
+}
+
+
 void SSGM_Powerup_Expire::Created(GameObject *obj)
 {
 	Commands->Start_Timer(obj,this,PowerupExpireTime,100);
@@ -1241,7 +1312,7 @@
 
 void SSGM_Powerup::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		if (strstr(Commands->Get_Preset_Name(obj),"CnC_POW_MineRemote_02"))
 		{
@@ -1797,7 +1868,7 @@
 
 void SSGM_Powerup_SBH::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"CnC_Nod_FlameThrower_2SF");
 	}
@@ -1805,7 +1876,7 @@
 
 void SSGM_Powerup_Havoc::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		int RandomNum = Commands->Get_Random_Int(1,4);
 		if (RandomNum == 1)
@@ -1828,21 +1899,21 @@
 }
 void SSGM_Powerup_Deadeye::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"CnC_GDI_MiniGunner_2SF");
 	}
 }
 void SSGM_Powerup_BHSniper::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"CnC_Nod_Minigunner_2SF");
 	}
 }
 void SSGM_Powerup_Sakura::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		int RandomNum = Commands->Get_Random_Int(1,2);
 		if (RandomNum == 1)
@@ -1857,7 +1928,7 @@
 }
 void SSGM_Powerup_SydneyPower::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		int RandomNum = Commands->Get_Random_Int(1,2);
 		if (RandomNum == 1)
@@ -1872,7 +1943,7 @@
 }
 void SSGM_Powerup_Raveshaw::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		int RandomNum = Commands->Get_Random_Int(1,2);
 		if (RandomNum == 1)
@@ -1887,7 +1958,7 @@
 }
 void SSGM_Powerup_Mobius::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		int RandomNum = Commands->Get_Random_Int(1,2);
 		if (RandomNum == 1)
@@ -1902,7 +1973,7 @@
 }
 void SSGM_Powerup_Mendoza::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		int RandomNum = Commands->Get_Random_Int(1,2);
 		if (RandomNum == 1)
@@ -1917,42 +1988,42 @@
 }
 void SSGM_Powerup_Hotwire::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"CnC_GDI_Engineer_2SF");
 	}
 }
 void SSGM_Powerup_Technician::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"CnC_Nod_Technician_0");
 	}
 }
 void SSGM_Powerup_Gunner::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"CnC_GDI_RocketSoldier_2SF");
 	}
 }
 void SSGM_Powerup_LCG::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"CnC_Nod_RocketSoldier_2SF");
 	}
 }
 void SSGM_Powerup_Patch::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"CnC_GDI_Grenadier_2SF");
 	}
 }
 void SSGM_Powerup_Nod_Officer::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"CnC_Nod_Minigunner_1Off");
 	}
@@ -1960,7 +2031,7 @@
 
 void SSGM_Powerup_GDI_Officer::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"CnC_GDI_MiniGunner_1Off");
 	}
@@ -1968,7 +2039,7 @@
 
 void SSGM_Powerup_GDI_Sydney::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"CnC_Sydney");
 	}
@@ -1976,7 +2047,7 @@
 
 void SSGM_Powerup_Chemwar::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"CnC_Nod_FlameThrower_1Off");
 	}
@@ -1984,7 +2055,7 @@
 
 void SSGM_Powerup_GDI_RSoldier::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"CnC_GDI_RocketSoldier_1Off");
 	}
@@ -1992,7 +2063,7 @@
 
 void SSGM_Powerup_Nod_RSoldier::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		Change_Character(sender,"CnC_Nod_RocketSoldier_1Off");
 	}
diff -uwr sourceold/scripts/gmgame.h source/scripts/gmgame.h
--- sourceold/scripts/gmgame.h	2012-02-18 09:50:34.061523400 +0800
+++ source/scripts/gmgame.h	2012-05-16 00:26:41.498046800 +0800
@@ -12,14 +12,16 @@
 #ifndef TT_INCLUDE_GMGAME_H
 #define TT_INCLUDE_GMGAME_H
 #include "gmplugin.h"
+#include "engine_ttdef.h"
 class SSGMGameManager {
 public:
 	static void Init();
 	static void Shutdown();
 	static bool ChatHook(int PlayerID,TextMessageEnum Type,const wchar_t *Message,int recieverID);
-	static bool RadioHook(int PlayerType, int PlayerID, int AnnouncementID, int IconID, uint8 AnnouncementType);
+	static bool RadioHook(int PlayerType, int PlayerID, int AnnouncementID, int IconID, AnnouncementEnum AnnouncementType);
 	static void ObjectCreateHook(void *data,GameObject *obj);
 	static void LoadLevelHook();
+	static void PreLoadLevelHook();
 	static void GameOverHook();
 	static void ConsoleOutputHook(const char *output);
 	static void LogFileHook(const char *output);
@@ -54,6 +56,7 @@
 	void Destroyed(GameObject *obj);
 	void Killed(GameObject *obj, GameObject *shooter);
 	void Damaged(GameObject *obj, GameObject *damager, float damage);
+	void Custom(GameObject *obj, int message, int param, GameObject *sender);
 	void Timer_Expired(GameObject *obj, int number);
 	public: void Register_Auto_Save_Variables();
 	bool triggerrepairing;
diff -uwr sourceold/scripts/gmplugin.h source/scripts/gmplugin.h
--- sourceold/scripts/gmplugin.h	2012-02-18 09:50:34.054687500 +0800
+++ source/scripts/gmplugin.h	2012-05-16 00:27:18.326171800 +0800
@@ -32,6 +32,7 @@
 	EVENT_RADIO_HOOK,
 	EVENT_STOCK_DAMAGE_HOOK,
 	EVENT_TT_DAMAGE_HOOK,
+	EVENT_PRE_LOAD_LEVEL_HOOK,
 	EVENT_COUNT
 };
 
@@ -54,9 +55,10 @@
 	virtual int OnVehiclePurchase(BaseControllerClass *base,GameObject *purchaser,unsigned int cost,unsigned int preset,const char *data) {return -1;}; //called on vehicle purchase
 	virtual int OnCharacterPurchase(BaseControllerClass *base,GameObject *purchaser,unsigned int cost,unsigned int preset,const char *data) {return -1;}; //called on character purchase
 	virtual void OnThink() {}; //called once per frame
-	virtual bool OnRadioCommand(int PlayerType, int PlayerID, int AnnouncementID, int IconID, uint8 AnnouncementType) {return true;} //called on radio command
+	virtual bool OnRadioCommand(int PlayerType, int PlayerID, int AnnouncementID, int IconID, AnnouncementEnum AnnouncementType) {return true;} //called on radio command
 	virtual bool OnStockDamage(PhysicalGameObj* damager, PhysicalGameObj* target, float damage, uint warheadId) { return true; } //called on damage from clients with version <4.0
 	virtual bool OnTtDamage(PhysicalGameObj* damager, PhysicalGameObj* target, const AmmoDefinitionClass* ammo, const char* bone) { return true; } //called on damage from clients with version >=4.0
+	virtual void OnPreLoadLevel() {}; //called on level load but before the client is sent any network updates
 };
 
 typedef Plugin *(*Plugin_Init_Type) ();
diff -uwr sourceold/scripts/gmsoldier.cpp source/scripts/gmsoldier.cpp
--- sourceold/scripts/gmsoldier.cpp	2011-10-11 23:04:34.123046800 +0800
+++ source/scripts/gmsoldier.cpp	2012-05-23 10:18:54.079101500 +0800
@@ -127,7 +127,7 @@
 	delete[] str;
 }
 
-void SSGM_Soldier::Detatch(GameObject *obj)
+void SSGM_Soldier::Detach(GameObject *obj)
 {
 	Unbind_Vehicle(obj, true);
 }
diff -uwr sourceold/scripts/gmsoldier.h source/scripts/gmsoldier.h
--- sourceold/scripts/gmsoldier.h	2011-10-11 21:52:39.229492100 +0800
+++ source/scripts/gmsoldier.h	2012-05-23 10:18:54.011718700 +0800
@@ -16,7 +16,7 @@
 	unsigned int RefillTime;
 	void Created(GameObject *obj);
 	void Destroyed(GameObject *obj);
-	void Detatch(GameObject *obj);
+	void Detach(GameObject *obj);
 	void Damaged(GameObject *obj,GameObject *damager,float amount);
 	void Killed(GameObject *obj,GameObject *killer);
 	void Custom(GameObject *obj, int message, int param, GameObject *sender);
diff -uwr sourceold/scripts/gmvehicle.cpp source/scripts/gmvehicle.cpp
--- sourceold/scripts/gmvehicle.cpp	2012-02-17 17:47:52.633789000 +0800
+++ source/scripts/gmvehicle.cpp	2012-05-23 10:18:53.952148400 +0800
@@ -21,10 +21,10 @@
 #include "gmgame.h"
 SCRIPTS_API VehicleGameObj *Find_My_Vehicle(GameObject *obj)
 {
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<VehicleGameObj> *x = GameObjManager::VehicleGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
+		VehicleGameObj *o = x->Data();
 		if (o)
 		{
 			SSGM_Vehicle *scr = (SSGM_Vehicle *)Find_Script_On_Object(o,"SSGM_Vehicle");
@@ -37,7 +37,7 @@
 				}
 				if (Commands->Find_Object(scr->OwnerID) == obj)
 				{
-					return o->As_VehicleGameObj();
+					return o;
 				}
 			}
 		}
@@ -237,9 +237,17 @@
 	triggerrepaired = true;
 	OwnerID = 0;
 	IconModelID = 0;
+	if (Get_Vehicle_Mode(obj) == VEHICLE_TYPE_TURRET)
+	{
+		Vector3	pos	= Commands->Get_Position(obj);
+		SSGMGameLog::Log_Gamelog("CREATED;BUILDING;%d;%s;%d;%d;%d;%d;%f;%f;%d", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj),	int(pos.Y),int(pos.X),int(pos.Z), int(Commands->Get_Facing(obj)), Commands->Get_Max_Health(obj),Commands->Get_Max_Shield_Strength(obj),Get_Object_Type(obj));
+	}
+	else
+	{
 	Vector3	pos	= Commands->Get_Position(obj);
 	SSGMGameLog::Log_Gamelog("CREATED;VEHICLE;%d;%s;%d;%d;%d;%d;%d;%d;%d",	Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(pos.Y),int(pos.X),int(pos.Z), int(Commands->Get_Facing(obj)), int(Commands->Get_Max_Health(obj)),int(Commands->Get_Max_Shield_Strength(obj)), Commands->Get_Player_Type(obj));
 }
+}
 
 void SSGM_Vehicle::Register_Auto_Save_Variables()
 {
@@ -379,6 +387,18 @@
 		delete[] str6;
 		SSGMGameLog::Log_Message(str,"_VEHKILL");
 	}
+	if (Get_Vehicle_Mode(obj) == VEHICLE_TYPE_TURRET)
+	{
+		Vector3	victimpos =	Commands->Get_Position(obj);
+		Vector3	damagerpos = Commands->Get_Position(killer);
+		const char *str = Get_Translated_Preset_Name_Ex(obj);
+		const char *str2 = Get_Translated_Preset_Name_Ex(killer);
+		SSGMGameLog::Log_Gamelog("KILLED;BUILDING;%d;%s;%d;%d;%d;%d;%d;%s;%d;%d;%d;%d;%s;%s;%s",Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(victimpos.Y), int(victimpos.X), int(victimpos.Z), int(Commands->Get_Facing(obj)), Commands->Get_ID(killer),	Commands->Get_Preset_Name(killer),	int(damagerpos.Y), int(damagerpos.X), int(damagerpos.Z), int(Commands->Get_Facing(killer)),Get_Current_Weapon(killer),str,str2);
+		delete[] str;
+		delete[] str2;
+	}
+	else
+	{
 	Vector3	victimpos =	Commands->Get_Position(obj);
 	Vector3	damagerpos = Commands->Get_Position(killer);
 	const char *str3 = Get_Translated_Preset_Name_Ex(obj);
@@ -387,6 +407,7 @@
 	delete[] str3;
 	delete[] str2;
 }
+}
 
 void SSGM_Vehicle::Destroyed(GameObject *obj)
 {
@@ -394,11 +415,19 @@
 	{
 		Commands->Destroy_Object(Commands->Find_Object(IconModelID));
 	}
+	if (Get_Vehicle_Mode(obj) == VEHICLE_TYPE_TURRET)
+	{
+		Vector3	pos	= Commands->Get_Position(obj);
+		SSGMGameLog::Log_Gamelog("DESTROYED;BUILDING;%d;%s;%d;%d;%d", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(pos.Y), int(pos.X), int(pos.Z));
+	}
+	else
+	{
 	Vector3	pos	= Commands->Get_Position(obj);
 	SSGMGameLog::Log_Gamelog("DESTROYED;VEHICLE;%d;%s;%d;%d;%d", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(pos.Y), int(pos.X), int(pos.Z));
 }
+}
 
-void SSGM_Vehicle::Detatch(GameObject *obj)
+void SSGM_Vehicle::Detach(GameObject *obj)
 {
 	if (Commands->Find_Object(IconModelID))
 	{
@@ -410,10 +439,19 @@
 {
 	if (amount != 0)
 	{
+		if (Get_Vehicle_Mode(obj) == VEHICLE_TYPE_TURRET)
+		{
+			Vector3	victimpos =	Commands->Get_Position(obj);
+			Vector3	damagerpos = Commands->Get_Position(damager);
+			SSGMGameLog::Log_Gamelog("DAMAGED;BUILDING;%d;%s;%d;%d;%d;%d;%d;%s;%d;%d;%d;%d;%f;%d;%d;%d", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(victimpos.Y), int(victimpos.X), int(victimpos.Z), int(Commands->Get_Facing(obj)), Commands->Get_ID(damager), Commands->Get_Preset_Name(damager), int(damagerpos.Y), int(damagerpos.X),	int(damagerpos.Z), int(Commands->Get_Facing(damager)), amount, int(Commands->Get_Health(obj)), int(Commands->Get_Shield_Strength(obj)),	int(Commands->Get_Points(obj)));
+		}
+		else
+		{
 		Vector3	victimpos =	Commands->Get_Position(obj);
 		Vector3	damagerpos = Commands->Get_Position(damager);
 		SSGMGameLog::Log_Gamelog("DAMAGED;VEHICLE;%d;%s;%d;%d;%d;%d;%d;%s;%d;%d;%d;%d;%f;%d;%d;%d", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj),	int(victimpos.Y), int(victimpos.X),	int(victimpos.Z), int(Commands->Get_Facing(obj)), Commands->Get_ID(damager), Commands->Get_Preset_Name(damager), int(damagerpos.Y),	int(damagerpos.X), int(damagerpos.Z), int(Commands->Get_Facing(damager)), amount, int(Commands->Get_Health(obj)), int(Commands->Get_Shield_Strength(obj)), int(Commands->Get_Points(damager)));
 	}
+	}
 	if (ShowExtraMessages)
 	{
 		if (triggerrepairing)
diff -uwr sourceold/scripts/gmvehicle.h source/scripts/gmvehicle.h
--- sourceold/scripts/gmvehicle.h	2011-10-11 21:52:37.589843700 +0800
+++ source/scripts/gmvehicle.h	2012-05-23 10:18:53.512695300 +0800
@@ -18,7 +18,7 @@
 	void Damaged(GameObject *obj,GameObject *damager,float amount);
 	void Killed(GameObject *obj,GameObject *killer);
 	void Destroyed(GameObject *obj);
-	void Detatch(GameObject *obj);
+	void Detach(GameObject *obj);
 	void Timer_Expired(GameObject *obj, int number);
 	bool triggerrepairing;
 	bool triggerrepaired;
diff -uwr sourceold/scripts/iran_scripts.cpp source/scripts/iran_scripts.cpp
--- sourceold/scripts/iran_scripts.cpp	2012-01-05 21:21:34.000000000 +0800
+++ source/scripts/iran_scripts.cpp	2012-04-24 12:40:48.691406200 +0800
@@ -83,7 +83,7 @@
 		saved = Commands->Get_ID(enter);
 		Commands->Start_Timer(obj,this,2.5f,1);
 	}
-	else if (Is_Vehicle(enter))
+	else if (enter->As_VehicleGameObj())
 	{
 		int type = Commands->Get_Player_Type(enter);
 		if ( type < 0 || type > 1 )
@@ -167,7 +167,7 @@
 		Commands->Start_Timer(obj,this,2.5f,1);
 	}
 
-	else if (Is_Vehicle(enter))
+	else if (enter->As_VehicleGameObj())
 	{
 		if (Get_Vehicle_Mode(enter) != VEHICLE_TYPE_FLYING)
 		{
@@ -187,7 +187,7 @@
 
 void Iran_Vehicle_Flying_Kill_Zone::Entered(GameObject *obj,GameObject *enter)
 {
-	if (Is_Vehicle(enter))
+	if (enter->As_VehicleGameObj())
 	{
 		if (Get_Vehicle_Mode(enter) == VEHICLE_TYPE_FLYING)
 		{
diff -uwr sourceold/scripts/jfwcine.cpp source/scripts/jfwcine.cpp
--- sourceold/scripts/jfwcine.cpp	2012-02-13 19:12:33.892000000 +0800
+++ source/scripts/jfwcine.cpp	2012-04-19 17:12:40.578125000 +0800
@@ -461,8 +461,8 @@
 {
 	float facing = Commands->Get_Facing(Owner());
 	Vector3 position = Commands->Get_Position(Owner());
-	position.X = (float)(cos(facing * 3.1415927 / 180) * 10 + position.X);
-	position.Y = (float)(sin(facing * 3.1415927 / 180) * 10 + position.Y);
+	position.X += cos(DEG_TO_RADF(facing)) * 10.0f;
+	position.Y += sin(DEG_TO_RADF(facing)) * 10.0f;
 	position.Z += 2.0;
 	ActionParamsStruct params;
 	params.Set_Basic(this,99,1);
diff -uwr sourceold/scripts/jfwdef.cpp source/scripts/jfwdef.cpp
--- sourceold/scripts/jfwdef.cpp	2011-10-11 23:05:19.216796800 +0800
+++ source/scripts/jfwdef.cpp	2012-04-24 12:41:09.166015600 +0800
@@ -1497,7 +1497,7 @@
 	}
 	if (!Is_VTOL(enemy))
 	{
-		SmartGameObj* obj1 = (SmartGameObj*)As_SmartGameObj(enemy);
+		SmartGameObj* obj1 = enemy->As_SmartGameObj();
 		if(!obj1 
 		|| !obj1->Is_Stealthed() 
 		|| Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(enemy)) <= Get_Float_Parameter("MaxStealthAttackDistance"))
